/*!
 * MediaElement.js
 * http://www.mediaelement.com/
 *
 * Wrapper that mimics native HTML5 MediaElement (audio and video)
 * using a variety of technologies (pure JavaScript, Flash, iframe)
 *
 * Copyright 2010-2017, John Dyer (http://j.hn/)
 * License: MIT
 *
 */
!function a(b,c,d){function e(g,h){if(!c[g]){if(!b[g]){var i="function"==typeof require&&require;if(!h&&i)return i(g,!0);if(f)return f(g,!0);var j=new Error("Cannot find module '"+g+"'");throw j.code="MODULE_NOT_FOUND",j}var k=c[g]={exports:{}};b[g][0].call(k.exports,function(a){var c=b[g][1][a];return e(c?c:a)},k,k.exports,a,b,c,d)}return c[g].exports}for(var f="function"==typeof require&&require,g=0;g<d.length;g++)e(d[g]);return e}({1:[function(a,b,c){},{}],2:[function(a,b,c){(function(c){var d="undefined"!=typeof c?c:"undefined"!=typeof window?window:{},e=a("min-document");if("undefined"!=typeof document)b.exports=document;else{var f=d["__GLOBAL_DOCUMENT_CACHE@4"];f||(f=d["__GLOBAL_DOCUMENT_CACHE@4"]=e),b.exports=f}}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"min-document":1}],3:[function(a,b,c){(function(a){"undefined"!=typeof window?b.exports=window:"undefined"!=typeof a?b.exports=a:"undefined"!=typeof self?b.exports=self:b.exports={}}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{}],4:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}Object.defineProperty(c,"__esModule",{value:!0});var e="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(a){return typeof a}:function(a){return a&&"function"==typeof Symbol&&a.constructor===Symbol&&a!==Symbol.prototype?"symbol":typeof a},f=a("./mejs"),g=d(f),h=a("../languages/en"),i=a("../utils/general"),j={lang:"en",en:h.EN};j.language=function(){for(var a=arguments.length,b=Array(a),c=0;a>c;c++)b[c]=arguments[c];if(null!==b&&void 0!==b&&b.length){if("string"!=typeof b[0])throw new TypeError("Language code must be a string value");if(!b[0].match(/^[a-z]{2}(\-[a-z]{2})?$/i))throw new TypeError("Language code must have format `xx` or `xx-xx`");j.lang=b[0],void 0===j[b[0]]?(b[1]=null!==b[1]&&void 0!==b[1]&&"object"===e(b[1])?b[1]:{},j[b[0]]=i.isObjectEmpty(b[1])?h.EN:b[1]):null!==b[1]&&void 0!==b[1]&&"object"===e(b[1])&&(j[b[0]]=b[1])}return j.lang},j.t=function(a){var b=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if("string"==typeof a&&a.length){var c=void 0,d=void 0,f=j.language(),g=function(a,b,c){if("object"!==("undefined"==typeof a?"undefined":e(a))||"number"!=typeof b||"number"!=typeof c)return a;var d=function(){return[function(){return arguments.length<=1?void 0:arguments[1]},function(){return 1===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:arguments.length<=2?void 0:arguments[2]},function(){return 0===(arguments.length<=0?void 0:arguments[0])||1===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:arguments.length<=2?void 0:arguments[2]},function(){return(arguments.length<=0?void 0:arguments[0])%10===1&&(arguments.length<=0?void 0:arguments[0])%100!==11?arguments.length<=1?void 0:arguments[1]:0!==(arguments.length<=0?void 0:arguments[0])?arguments.length<=2?void 0:arguments[2]:arguments.length<=3?void 0:arguments[3]},function(){return 1===(arguments.length<=0?void 0:arguments[0])||11===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:2===(arguments.length<=0?void 0:arguments[0])||12===(arguments.length<=0?void 0:arguments[0])?arguments.length<=2?void 0:arguments[2]:(arguments.length<=0?void 0:arguments[0])>2&&(arguments.length<=0?void 0:arguments[0])<20?arguments.length<=3?void 0:arguments[3]:arguments.length<=4?void 0:arguments[4]},function(){return 1===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:0===(arguments.length<=0?void 0:arguments[0])||(arguments.length<=0?void 0:arguments[0])%100>0&&(arguments.length<=0?void 0:arguments[0])%100<20?arguments.length<=2?void 0:arguments[2]:arguments.length<=3?void 0:arguments[3]},function(){return(arguments.length<=0?void 0:arguments[0])%10===1&&(arguments.length<=0?void 0:arguments[0])%100!==11?arguments.length<=1?void 0:arguments[1]:(arguments.length<=0?void 0:arguments[0])%10>=2&&((arguments.length<=0?void 0:arguments[0])%100<10||(arguments.length<=0?void 0:arguments[0])%100>=20)?arguments.length<=2?void 0:arguments[2]:[3]},function(){return(arguments.length<=0?void 0:arguments[0])%10===1&&(arguments.length<=0?void 0:arguments[0])%100!==11?arguments.length<=1?void 0:arguments[1]:(arguments.length<=0?void 0:arguments[0])%10>=2&&(arguments.length<=0?void 0:arguments[0])%10<=4&&((arguments.length<=0?void 0:arguments[0])%100<10||(arguments.length<=0?void 0:arguments[0])%100>=20)?arguments.length<=2?void 0:arguments[2]:arguments.length<=3?void 0:arguments[3]},function(){return 1===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:(arguments.length<=0?void 0:arguments[0])>=2&&(arguments.length<=0?void 0:arguments[0])<=4?arguments.length<=2?void 0:arguments[2]:arguments.length<=3?void 0:arguments[3]},function(){return 1===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:(arguments.length<=0?void 0:arguments[0])%10>=2&&(arguments.length<=0?void 0:arguments[0])%10<=4&&((arguments.length<=0?void 0:arguments[0])%100<10||(arguments.length<=0?void 0:arguments[0])%100>=20)?arguments.length<=2?void 0:arguments[2]:arguments.length<=3?void 0:arguments[3]},function(){return(arguments.length<=0?void 0:arguments[0])%100===1?arguments.length<=2?void 0:arguments[2]:(arguments.length<=0?void 0:arguments[0])%100===2?arguments.length<=3?void 0:arguments[3]:(arguments.length<=0?void 0:arguments[0])%100===3||(arguments.length<=0?void 0:arguments[0])%100===4?arguments.length<=4?void 0:arguments[4]:arguments.length<=1?void 0:arguments[1]},function(){return 1===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:2===(arguments.length<=0?void 0:arguments[0])?arguments.length<=2?void 0:arguments[2]:(arguments.length<=0?void 0:arguments[0])>2&&(arguments.length<=0?void 0:arguments[0])<7?arguments.length<=3?void 0:arguments[3]:(arguments.length<=0?void 0:arguments[0])>6&&(arguments.length<=0?void 0:arguments[0])<11?arguments.length<=4?void 0:arguments[4]:arguments.length<=5?void 0:arguments[5]},function(){return 0===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:1===(arguments.length<=0?void 0:arguments[0])?arguments.length<=2?void 0:arguments[2]:2===(arguments.length<=0?void 0:arguments[0])?arguments.length<=3?void 0:arguments[3]:(arguments.length<=0?void 0:arguments[0])%100>=3&&(arguments.length<=0?void 0:arguments[0])%100<=10?arguments.length<=4?void 0:arguments[4]:(arguments.length<=0?void 0:arguments[0])%100>=11?arguments.length<=5?void 0:arguments[5]:arguments.length<=6?void 0:arguments[6]},function(){return 1===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:0===(arguments.length<=0?void 0:arguments[0])||(arguments.length<=0?void 0:arguments[0])%100>1&&(arguments.length<=0?void 0:arguments[0])%100<11?arguments.length<=2?void 0:arguments[2]:(arguments.length<=0?void 0:arguments[0])%100>10&&(arguments.length<=0?void 0:arguments[0])%100<20?arguments.length<=3?void 0:arguments[3]:arguments.length<=4?void 0:arguments[4]},function(){return(arguments.length<=0?void 0:arguments[0])%10===1?arguments.length<=1?void 0:arguments[1]:(arguments.length<=0?void 0:arguments[0])%10===2?arguments.length<=2?void 0:arguments[2]:arguments.length<=3?void 0:arguments[3]},function(){return 11!==(arguments.length<=0?void 0:arguments[0])&&(arguments.length<=0?void 0:arguments[0])%10===1?arguments.length<=1?void 0:arguments[1]:arguments.length<=2?void 0:arguments[2]},function(){return 1===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:(arguments.length<=0?void 0:arguments[0])%10>=2&&(arguments.length<=0?void 0:arguments[0])%10<=4&&((arguments.length<=0?void 0:arguments[0])%100<10||(arguments.length<=0?void 0:arguments[0])%100>=20)?arguments.length<=2?void 0:arguments[2]:arguments.length<=3?void 0:arguments[3]},function(){return 1===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:2===(arguments.length<=0?void 0:arguments[0])?arguments.length<=2?void 0:arguments[2]:8!==(arguments.length<=0?void 0:arguments[0])&&11!==(arguments.length<=0?void 0:arguments[0])?arguments.length<=3?void 0:arguments[3]:arguments.length<=4?void 0:arguments[4]},function(){return 0===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:arguments.length<=2?void 0:arguments[2]},function(){return 1===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:2===(arguments.length<=0?void 0:arguments[0])?arguments.length<=2?void 0:arguments[2]:3===(arguments.length<=0?void 0:arguments[0])?arguments.length<=3?void 0:arguments[3]:arguments.length<=4?void 0:arguments[4]},function(){return 0===(arguments.length<=0?void 0:arguments[0])?arguments.length<=1?void 0:arguments[1]:1===(arguments.length<=0?void 0:arguments[0])?arguments.length<=2?void 0:arguments[2]:arguments.length<=3?void 0:arguments[3]}]}();return d[c].apply(null,[b].concat(a))};return void 0!==j[f]&&(c=j[f][a],null!==b&&"number"==typeof b&&(d=j[f]["mejs.plural-form"],c=g.apply(null,[c,b,d]))),!c&&j.en&&(c=j.en[a],null!==b&&"number"==typeof b&&(d=j.en["mejs.plural-form"],c=g.apply(null,[c,b,d]))),c=c||a,null!==b&&"number"==typeof b&&(c=c.replace("%1",b)),i.escapeHTML(c)}return a},g["default"].i18n=j,"undefined"!=typeof mejsL10n&&g["default"].i18n.language(mejsL10n.language,mejsL10n.strings),c["default"]=j},{"../languages/en":8,"../utils/general":21,"./mejs":6}],5:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}function e(a,b){if(!(a instanceof b))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(c,"__esModule",{value:!0});var f=a("global/window"),g=d(f),h=a("global/document"),i=d(h),j=a("./mejs"),k=d(j),l=a("../utils/media"),m=a("./renderer"),n=function o(a,b){var c=this;e(this,o);var d=this;d.defaults={renderers:[],fakeNodeName:"mediaelementwrapper",pluginPath:"build/"},b=Object.assign(d.defaults,b),d.mediaElement=i["default"].createElement(b.fakeNodeName),d.mediaElement.options=b;var f=a,g=void 0,h=void 0;"string"==typeof a?d.mediaElement.originalNode=i["default"].getElementById(a):(d.mediaElement.originalNode=a,f=a.id),f=f||"mejs_"+Math.random().toString().slice(2),void 0!==d.mediaElement.originalNode&&null!==d.mediaElement.originalNode&&d.mediaElement.appendChild&&(d.mediaElement.originalNode.setAttribute("id",f+"_from_mejs"),d.mediaElement.originalNode.parentNode.insertBefore(d.mediaElement,d.mediaElement.originalNode),d.mediaElement.appendChild(d.mediaElement.originalNode)),d.mediaElement.id=f,d.mediaElement.renderers={},d.mediaElement.renderer=null,d.mediaElement.rendererName=null,d.mediaElement.changeRenderer=function(a,b){var d=c;if(void 0!==d.mediaElement.renderer&&null!==d.mediaElement.renderer&&d.mediaElement.renderer.name===a)return d.mediaElement.renderer.pause(),d.mediaElement.renderer.stop&&d.mediaElement.renderer.stop(),d.mediaElement.renderer.show(),d.mediaElement.renderer.setSrc(b[0].src),!0;void 0!==d.mediaElement.renderer&&null!==d.mediaElement.renderer&&(d.mediaElement.renderer.pause(),d.mediaElement.renderer.stop&&d.mediaElement.renderer.stop(),d.mediaElement.renderer.hide());var e=d.mediaElement.renderers[a],f=null;if(void 0!==e&&null!==e)return e.show(),e.setSrc(b[0].src),d.mediaElement.renderer=e,d.mediaElement.rendererName=a,!0;var i=d.mediaElement.options.renderers.length?d.mediaElement.options.renderers:m.renderer.order;for(g=0,h=i.length;h>g;g++){var j=i[g];if(j===a){var k=m.renderer.renderers;f=k[j];var l=Object.assign(f.options,d.mediaElement.options);return e=f.create(d.mediaElement,l,b),e.name=a,d.mediaElement.renderers[f.name]=e,d.mediaElement.renderer=e,d.mediaElement.rendererName=a,e.show(),!0}}return!1},d.mediaElement.setSize=function(a,b){void 0!==d.mediaElement.renderer&&null!==d.mediaElement.renderer&&d.mediaElement.renderer.setSize(a,b)};var j=k["default"].html5media.properties,n=k["default"].html5media.methods,p=function(a,b,c,d){var e=a[b],f=function(){return c.apply(a,[e])},g=function(b){return e=d.apply(a,[b])};Object.defineProperty?Object.defineProperty(a,b,{get:f,set:g}):a.__defineGetter__&&(a.__defineGetter__(b,f),a.__defineSetter__(b,g))},q=function(a){"src"!==a&&!function(){var b=""+a.substring(0,1).toUpperCase()+a.substring(1),c=function(){return d.mediaElement.renderer["get"+b]()},e=function(a){d.mediaElement.renderer["set"+b](a)};p(d.mediaElement,a,c,e),d.mediaElement["get"+b]=c,d.mediaElement["set"+b]=e}()},r=function(){return d.mediaElement.renderer.getSrc()},s=function(a){var b=[];if("string"==typeof a)b.push({src:a,type:a?l.getTypeFromFile(a):""});else for(g=0,h=a.length;h>g;g++){var c=l.absolutizeUrl(a[g].src),e=a[g].type;b.push({src:c,type:""!==e&&null!==e&&void 0!==e||!c?e:l.getTypeFromFile(c)})}var f=m.renderer.select(b,d.mediaElement.options.renderers.length?d.mediaElement.options.renderers:[]),j=void 0;return d.mediaElement.originalNode.setAttribute("src",b[0].src||""),null===f?(j=i["default"].createEvent("HTMLEvents"),j.initEvent("error",!1,!1),j.message="No renderer found",void d.mediaElement.dispatchEvent(j)):(d.mediaElement.changeRenderer(f.rendererName,b),void((void 0===d.mediaElement.renderer||null===d.mediaElement.renderer)&&(j=i["default"].createEvent("HTMLEvents"),j.initEvent("error",!1,!1),j.message="Error creating renderer",d.mediaElement.dispatchEvent(j))))},t=function(a){d.mediaElement[a]=function(){for(var b=arguments.length,c=Array(b),e=0;b>e;e++)c[e]=arguments[e];return"function"==typeof d.mediaElement.renderer[a]?d.mediaElement.renderer[a](c):null}};for(p(d.mediaElement,"src",r,s),d.mediaElement.getSrc=r,d.mediaElement.setSrc=s,g=0,h=j.length;h>g;g++)q(j[g]);for(g=0,h=n.length;h>g;g++)t(n[g]);if(d.mediaElement.addEventListener||(d.mediaElement.events={},d.mediaElement.addEventListener=function(a,b){d.mediaElement.events[a]=d.mediaElement.events[a]||[],d.mediaElement.events[a].push(b)},d.mediaElement.removeEventListener=function(a,b){if(!a)return d.mediaElement.events={},!0;var c=d.mediaElement.events[a];if(!c)return!0;if(!b)return d.mediaElement.events[a]=[],!0;for(var e=0,f=c.length;f>e;e++)if(c[e]===b)return d.mediaElement.events[a].splice(e,1),!0;return!1},d.mediaElement.dispatchEvent=function(a){var b=d.mediaElement.events[a.type];if(b)for(g=0,h=b.length;h>g;g++)b[g].apply(null,[a])}),null!==d.mediaElement.originalNode){var u=[];switch(d.mediaElement.originalNode.nodeName.toLowerCase()){case"iframe":u.push({type:"",src:d.mediaElement.originalNode.getAttribute("src")});break;case"audio":case"video":var v=void 0,w=void 0,x=void 0,y=d.mediaElement.originalNode.childNodes.length,z=d.mediaElement.originalNode.getAttribute("src");if(z){var A=d.mediaElement.originalNode;u.push({type:l.formatType(z,A.getAttribute("type")),src:z})}for(g=0;y>g;g++)v=d.mediaElement.originalNode.childNodes[g],v.nodeType===Node.ELEMENT_NODE&&"source"===v.tagName.toLowerCase()&&(w=v.getAttribute("src"),x=l.formatType(w,v.getAttribute("type")),u.push({type:x,src:w}))}u.length>0&&(d.mediaElement.src=u)}return d.mediaElement.options.success&&d.mediaElement.options.success(d.mediaElement,d.mediaElement.originalNode),d.mediaElement};g["default"].MediaElement=n,c["default"]=n},{"../utils/media":22,"./mejs":6,"./renderer":7,"global/document":2,"global/window":3}],6:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}Object.defineProperty(c,"__esModule",{value:!0});var e=a("global/window"),f=d(e),g={};g.version="3.0.0",g.html5media={properties:["volume","src","currentTime","muted","duration","paused","ended","error","currentSrc","networkState","preload","buffered","bufferedBytes","bufferedTime","readyState","seeking","initialTime","startOffsetTime","defaultPlaybackRate","playbackRate","played","seekable","autoplay","loop","controls"],methods:["load","play","pause","canPlayType"],events:["loadstart","progress","suspend","abort","error","emptied","stalled","play","pause","loadedmetadata","loadeddata","waiting","playing","canplay","canplaythrough","seeking","seeked","timeupdate","ended","ratechange","durationchange","volumechange"],mediaTypes:["audio/mp3","audio/ogg","audio/oga","audio/wav","audio/x-wav","audio/wave","audio/x-pn-wav","audio/mpeg","audio/mp4","video/mp4","video/webm","video/ogg"]},f["default"].mejs=g,c["default"]=g},{"global/window":3}],7:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}function e(a,b){if(!(a instanceof b))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(c,"__esModule",{value:!0}),c.renderer=void 0;var f="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(a){return typeof a}:function(a){return a&&"function"==typeof Symbol&&a.constructor===Symbol&&a!==Symbol.prototype?"symbol":typeof a},g=function(){function a(a,b){for(var c=0;c<b.length;c++){var d=b[c];d.enumerable=d.enumerable||!1,d.configurable=!0,"value"in d&&(d.writable=!0),Object.defineProperty(a,d.key,d)}}return function(b,c,d){return c&&a(b.prototype,c),d&&a(b,d),b}}(),h=a("./mejs"),i=d(h),j=function(){function a(){e(this,a),this.renderers={},this.order=[]}return g(a,[{key:"add",value:function(a){if(void 0===a.name)throw new TypeError("renderer must contain at least `name` property");this.renderers[a.name]=a,this.order.push(a.name)}},{key:"select",value:function(a){var b=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[];b=b.length?b:this.order;for(var c=0,d=b.length;d>c;c++){var e=b[c],f=this.renderers[e];if(null!==f&&void 0!==f)for(var g=0,h=a.length;h>g;g++)if("function"==typeof f.canPlayType&&"string"==typeof a[g].type&&f.canPlayType(a[g].type))return{rendererName:f.name,src:a[g].src}}return null}},{key:"order",set:function(a){if(!Array.isArray(a))throw new TypeError("order must be an array of strings.");this._order=a},get:function(){return this._order}},{key:"renderers",set:function(a){if(null!==a&&"object"!==("undefined"==typeof a?"undefined":f(a)))throw new TypeError("renderers must be an array of objects.");this._renderers=a},get:function(){return this._renderers}}]),a}(),k=c.renderer=new j;i["default"].Renderers=k},{"./mejs":6}],8:[function(a,b,c){"use strict";/*!
 * This is a `i18n` language object.
 *
 * English; This can serve as a template for other languages to translate
 *
 * @author
 *   TBD
 *   Sascha Greuel (Twitter: @SoftCreatR)
 *
 * @see core/i18n.js
 */
Object.defineProperty(c,"__esModule",{value:!0});c.EN={"mejs.plural-form":1,"mejs.install-flash":"You are using a browser that does not have Flash player enabled or installed. Please turn on your Flash player plugin or download the latest version from https://get.adobe.com/flashplayer/","mejs.fullscreen-off":"Turn off Fullscreen","mejs.fullscreen-on":"Go Fullscreen","mejs.download-video":"Download Video","mejs.fullscreen":"Fullscreen","mejs.time-jump-forward":["Jump forward 1 second","Jump forward %1 seconds"],"mejs.loop":"Toggle Loop","mejs.play":"Play","mejs.pause":"Pause","mejs.close":"Close","mejs.time-slider":"Time Slider","mejs.time-help-text":"Use Left/Right Arrow keys to advance one second, Up/Down arrows to advance ten seconds.","mejs.time-skip-back":["Skip back 1 second","Skip back %1 seconds"],"mejs.captions-subtitles":"Captions/Subtitles","mejs.none":"None","mejs.mute-toggle":"Mute Toggle","mejs.volume-help-text":"Use Up/Down Arrow keys to increase or decrease volume.","mejs.unmute":"Unmute","mejs.mute":"Mute","mejs.volume-slider":"Volume Slider","mejs.video-player":"Video Player","mejs.audio-player":"Audio Player","mejs.ad-skip":"Skip ad","mejs.ad-skip-info":["Skip in 1 second","Skip in %1 seconds"],"mejs.source-chooser":"Source Chooser","mejs.stop":"Stop","mejs.speed-rate":"Speed Rate","mejs.live-broadcast":"Live Broadcast","mejs.afrikaans":"Afrikaans","mejs.albanian":"Albanian","mejs.arabic":"Arabic","mejs.belarusian":"Belarusian","mejs.bulgarian":"Bulgarian","mejs.catalan":"Catalan","mejs.chinese":"Chinese","mejs.chinese-simplified":"Chinese (Simplified)","mejs.chinese-traditional":"Chinese (Traditional)","mejs.croatian":"Croatian","mejs.czech":"Czech","mejs.danish":"Danish","mejs.dutch":"Dutch","mejs.english":"English","mejs.estonian":"Estonian","mejs.filipino":"Filipino","mejs.finnish":"Finnish","mejs.french":"French","mejs.galician":"Galician","mejs.german":"German","mejs.greek":"Greek","mejs.haitian-creole":"Haitian Creole","mejs.hebrew":"Hebrew","mejs.hindi":"Hindi","mejs.hungarian":"Hungarian","mejs.icelandic":"Icelandic","mejs.indonesian":"Indonesian","mejs.irish":"Irish","mejs.italian":"Italian","mejs.japanese":"Japanese","mejs.korean":"Korean","mejs.latvian":"Latvian","mejs.lithuanian":"Lithuanian","mejs.macedonian":"Macedonian","mejs.malay":"Malay","mejs.maltese":"Maltese","mejs.norwegian":"Norwegian","mejs.persian":"Persian","mejs.polish":"Polish","mejs.portuguese":"Portuguese","mejs.romanian":"Romanian","mejs.russian":"Russian","mejs.serbian":"Serbian","mejs.slovak":"Slovak","mejs.slovenian":"Slovenian","mejs.spanish":"Spanish","mejs.swahili":"Swahili","mejs.swedish":"Swedish","mejs.tagalog":"Tagalog","mejs.thai":"Thai","mejs.turkish":"Turkish","mejs.ukrainian":"Ukrainian","mejs.vietnamese":"Vietnamese","mejs.welsh":"Welsh","mejs.yiddish":"Yiddish"}},{}],9:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}var e="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(a){return typeof a}:function(a){return a&&"function"==typeof Symbol&&a.constructor===Symbol&&a!==Symbol.prototype?"symbol":typeof a},f=a("global/window"),g=d(f),h=a("global/document"),i=d(h),j=a("../core/mejs"),k=d(j),l=a("../core/renderer"),m=a("../utils/dom"),n=a("../utils/media"),o={isSDKStarted:!1,isSDKLoaded:!1,iframeQueue:[],enqueueIframe:function(a){o.isLoaded?o.createIframe(a):(o.loadIframeApi(),o.iframeQueue.push(a))},loadIframeApi:function(){if(!o.isSDKStarted){var a=i["default"].createElement("script");a.async=!0,a.src="//api.dmcdn.net/all.js";var b=i["default"].getElementsByTagName("script")[0];b.parentNode.insertBefore(a,b),o.isSDKStarted=!0}},apiReady:function(){for(o.isLoaded=!0,o.isSDKLoaded=!0;o.iframeQueue.length>0;){var a=o.iframeQueue.pop();o.createIframe(a)}},createIframe:function(a){var b=DM.player(a.container,{height:a.height||"100%",width:a.width||"100%",video:a.videoId,params:Object.assign({api:!0},a.params),origin:location.host});b.addEventListener("apiready",function(){g["default"]["__ready__"+a.id](b,{paused:!0,ended:!1})})},getDailyMotionId:function(a){var b=a.split("/"),c=b[b.length-1],d=c.split("_");return d[0]}},p={name:"dailymotion_iframe",options:{prefix:"dailymotion_iframe",dailymotion:{width:"100%",height:"100%",params:{autoplay:!1,chromeless:1,info:0,logo:0,related:0}}},canPlayType:function(a){return["video/dailymotion","video/x-dailymotion"].includes(a)},create:function(a,b,c){var d={};d.options=b,d.id=a.id+"_"+b.prefix,d.mediaElement=a;var f=[],h=!1,j=null,l=null,n=void 0,p=void 0,q=void 0,r=k["default"].html5media.properties,s=function(b){var c=""+b.substring(0,1).toUpperCase()+b.substring(1);d["get"+c]=function(){if(null!==j){var c=null,d=function(){switch(b){case"currentTime":return{v:j.currentTime};case"duration":return{v:isNaN(j.duration)?0:j.duration};case"volume":return{v:j.volume};case"paused":return{v:j.paused};case"ended":return{v:j.ended};case"muted":return{v:j.muted};case"buffered":var c=j.bufferedTime,d=j.duration;return{v:{start:function(){return 0},end:function(){return c/d},length:1}};case"src":return{v:a.originalNode.getAttribute("src")}}}();return"object"===("undefined"==typeof d?"undefined":e(d))?d.v:c}return null},d["set"+c]=function(c){if(null!==j)switch(b){case"src":var e="string"==typeof c?c:c[0].src;j.load(o.getDailyMotionId(e));break;case"currentTime":j.seek(c);break;case"muted":c?j.setMuted(!0):j.setMuted(!1),setTimeout(function(){var b=m.createEvent("volumechange",d);a.dispatchEvent(b)},50);break;case"volume":j.setVolume(c),setTimeout(function(){var b=m.createEvent("volumechange",d);a.dispatchEvent(b)},50)}else f.push({type:"set",propName:b,value:c})}};for(p=0,q=r.length;q>p;p++)s(r[p]);var t=k["default"].html5media.methods,u=function(a){d[a]=function(){if(null!==j)switch(a){case"play":return j.play();case"pause":return j.pause();case"load":return null}else f.push({type:"call",methodName:a})}};for(p=0,q=t.length;q>p;p++)u(t[p]);g["default"]["__ready__"+d.id]=function(b){if(h=!0,a.dmPlayer=j=b,f.length)for(p=0,q=f.length;q>p;p++){var c=f[p];if("set"===c.type){var e=c.propName,g=""+e.substring(0,1).toUpperCase()+e.substring(1);d["set"+g](c.value)}else"call"===c.type&&d[c.methodName]()}l=i["default"].getElementById(d.id),n=["mouseover","mouseout"];var o=function(b){var c=m.createEvent(b.type,d);a.dispatchEvent(c)};for(var r in n)m.addEvent(l,n[r],o);n=k["default"].html5media.events,n=n.concat(["click","mouseover","mouseout"]);var s=function(b){"ended"!==b&&j.addEventListener(b,function(b){var c=m.createEvent(b.type,j);a.dispatchEvent(c)})};for(p=0,q=n.length;q>p;p++)s(n[p]);j.addEventListener("ad_start",function(){var b=m.createEvent("play",j);a.dispatchEvent(b),b=m.createEvent("progress",j),a.dispatchEvent(b),b=m.createEvent("timeupdate",j),a.dispatchEvent(b)}),j.addEventListener("ad_timeupdate",function(){var b=m.createEvent("timeupdate",j);a.dispatchEvent(b)}),j.addEventListener("ad_pause",function(){var b=m.createEvent("pause",j);a.dispatchEvent(b)}),j.addEventListener("ad_end",function(){var b=m.createEvent("ended",j);a.dispatchEvent(b)}),j.addEventListener("video_start",function(){var b=m.createEvent("play",j);a.dispatchEvent(b),b=m.createEvent("timeupdate",j),a.dispatchEvent(b)}),j.addEventListener("video_end",function(){var b=m.createEvent("ended",j);a.dispatchEvent(b)}),j.addEventListener("progress",function(){var b=m.createEvent("timeupdate",j);a.dispatchEvent(b)}),j.addEventListener("durationchange",function(){var b=m.createEvent("timeupdate",j);a.dispatchEvent(b)});var t=["rendererready","loadeddata","loadedmetadata","canplay"];for(p=0,q=t.length;q>p;p++){var u=m.createEvent(t[p],d);a.dispatchEvent(u)}};var v=i["default"].createElement("div");v.id=d.id,a.appendChild(v),a.originalNode&&(v.style.width=a.originalNode.style.width,v.style.height=a.originalNode.style.height),a.originalNode.style.display="none";var w=o.getDailyMotionId(c[0].src),x=Object.assign({id:d.id,container:v,videoId:w,autoplay:!!a.originalNode.getAttribute("autoplay")},d.options.dailymotion);return o.enqueueIframe(x),d.hide=function(){d.stopInterval(),d.pause(),l&&(l.style.display="none")},d.show=function(){l&&(l.style.display="")},d.setSize=function(a,b){l.width=a,l.height=b},d.destroy=function(){j.destroy()},d.interval=null,d.startInterval=function(){d.interval=setInterval(function(){o.sendEvent(d.id,j,"timeupdate",{paused:!1,ended:!1})},250)},d.stopInterval=function(){d.interval&&clearInterval(d.interval)},d}};n.typeChecks.push(function(a){return a=a.toLowerCase(),a.includes("//dailymotion.com")||a.includes("www.dailymotion.com")||a.includes("//dai.ly")?"video/x-dailymotion":null}),g["default"].dmAsyncInit=function(){o.apiReady()},l.renderer.add(p)},{"../core/mejs":6,"../core/renderer":7,"../utils/dom":20,"../utils/media":22,"global/document":2,"global/window":3}],10:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}var e=a("global/window"),f=d(e),g=a("global/document"),h=d(g),i=a("../core/mejs"),j=d(i),k=a("../core/renderer"),l=a("../utils/dom"),m=a("../utils/media"),n=a("../utils/constants"),o={isMediaLoaded:!1,creationQueue:[],prepareSettings:function(a){o.isLoaded?o.createInstance(a):(o.loadScript(a),o.creationQueue.push(a))},loadScript:function(a){o.isScriptLoaded||("undefined"!=typeof dashjs?o.createInstance(a):!function(){a.options.path="string"==typeof a.options.path?a.options.path:"//cdn.dashjs.org/latest/dash.mediaplayer.min.js";var b=h["default"].createElement("script"),c=h["default"].getElementsByTagName("script")[0],d=!1;b.src=a.options.path,b.onload=b.onreadystatechange=function(){d||this.readyState&&void 0!==this.readyState&&"loaded"!==this.readyState&&"complete"!==this.readyState||(d=!0,o.mediaReady(),b.onload=b.onreadystatechange=null)},c.parentNode.insertBefore(b,c)}(),o.isScriptLoaded=!0)},mediaReady:function(){for(o.isLoaded=!0,o.isScriptLoaded=!0;o.creationQueue.length>0;){var a=o.creationQueue.pop();o.createInstance(a)}},createInstance:function(a){var b=dashjs.MediaPlayer().create();f["default"]["__ready__"+a.id](b)}},p={name:"native_mdash",options:{prefix:"native_mdash",dash:{path:"//cdn.dashjs.org/latest/dash.mediaplayer.min.js",debug:!1}},canPlayType:function(a){return n.HAS_MSE&&["application/dash+xml"].includes(a)},create:function(a,b,c){var d=null,e=a.originalNode,g=a.id+"_"+b.prefix,i=void 0,m={},n=void 0,p=void 0;d=e.cloneNode(!0),b=Object.assign(b,a.options);var q=j["default"].html5media.properties,r=function(a){var b=""+a.substring(0,1).toUpperCase()+a.substring(1);d["get"+b]=function(){return null!==i?d[a]:null},d["set"+b]=function(b){null!==i?("src"===a&&(i.attachSource(b),d.getAttribute("autoplay")&&d.play()),d[a]=b):m.push({type:"set",propName:a,value:b})}};for(n=0,p=q.length;p>n;n++)r(q[n]);if(f["default"]["__ready__"+g]=function(c){if(a.dashPlayer=i=c,i.getDebug().setLogToBrowserConsole(b.dash.debug),m.length)for(n=0,p=m.length;p>n;n++){var e=m[n];if("set"===e.type){var f=e.propName,g=""+f.substring(0,1).toUpperCase()+f.substring(1);d["set"+g](e.value)}else"call"===e.type&&d[e.methodName]()}var k=j["default"].html5media.events,o=dashjs.MediaPlayer.events,q=function(b){"loadedmetadata"===b&&i.initialize(d,d.src,!1),d.addEventListener(b,function(b){var c=h["default"].createEvent("HTMLEvents");c.initEvent(b.type,b.bubbles,b.cancelable),a.dispatchEvent(c)})};for(k=k.concat(["click","mouseover","mouseout"]),n=0,p=k.length;p>n;n++)q(k[n]);var r=function(b){var c=l.createEvent(b.type,d);c.data=b,a.dispatchEvent(c),"error"===b.type.toLowerCase()&&console.error(b)};for(var s in o)o.hasOwnProperty(s)&&i.on(o[s],r)},c&&c.length>0)for(n=0,p=c.length;p>n;n++)if(k.renderer.renderers[b.prefix].canPlayType(c[n].type)){d.setAttribute("src",c[n].src);break}d.setAttribute("id",g),e.parentNode.insertBefore(d,e),e.removeAttribute("autoplay"),e.style.display="none",o.prepareSettings({options:b.dash,id:g}),d.setSize=function(a,b){return d.style.width=a+"px",d.style.height=b+"px",d},d.hide=function(){return d.pause(),d.style.display="none",d},d.show=function(){return d.style.display="",d};var s=l.createEvent("rendererready",d);return a.dispatchEvent(s),d}};m.typeChecks.push(function(a){return a=a.toLowerCase(),a.includes(".mpd")?"application/dash+xml":null}),k.renderer.add(p)},{"../core/mejs":6,"../core/renderer":7,"../utils/constants":19,"../utils/dom":20,"../utils/media":22,"global/document":2,"global/window":3}],11:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}var e=a("global/window"),f=d(e),g=a("global/document"),h=d(g),i=a("../core/mejs"),j=d(i),k=a("../core/renderer"),l=a("../utils/general"),m=a("../utils/dom"),n=a("../utils/media"),o={name:"facebook",options:{prefix:"facebook",facebook:{appId:"{your-app-id}",xfbml:!0,version:"v2.6"}},canPlayType:function(a){return["video/facebook","video/x-facebook"].includes(a)},create:function(a,b,c){function d(b){for(var c=0,d=b.length;d>c;c++){var e=j["default"].Utils.createEvent(b[c],g);a.dispatchEvent(e)}}function e(b,c){r=b,k=h["default"].createElement("div"),k.id=g.id,k.className="fb-video",k.setAttribute("data-href",b),k.setAttribute("data-allowfullscreen","true"),k.setAttribute("data-controls","false"),a.originalNode.parentNode.insertBefore(k,a.originalNode),a.originalNode.style.display="none",f["default"].fbAsyncInit=function(){FB.init(c),FB.Event.subscribe("xfbml.ready",function(a){"video"===a.type&&!function(){i=a.instance;var b=k.getElementsByTagName("iframe")[0],c=parseInt(f["default"].getComputedStyle(b,null).width),e=parseInt(b.style.height);g.setSize(c,e),d(["mouseover","mouseout"]);var h=["startedPlaying","paused","finishedPlaying","startedBuffering","finishedBuffering"];for(t=0,u=h.length;u>t;t++){var j=h[t],m=s[j];void 0===m||null===m||l.isObjectEmpty(m)||"function"!=typeof m.removeListener||m.removeListener(j)}if(n.length)for(t=0,u=n.length;u>t;t++){var r=n[t];if("set"===r.type){var v=r.propName,w=""+v.substring(0,1).toUpperCase()+v.substring(1);g["set"+w](r.value)}else"call"===r.type&&g[r.methodName]()}d(["rendererready","ready","loadeddata","canplay","progress"]),d(["loadedmetadata","timeupdate","progress"]);var x=void 0;s.startedPlaying=i.subscribe("startedPlaying",function(){q||(q=!0),o=!1,p=!1,d(["play","playing","timeupdate"]),x=setInterval(function(){i.getCurrentPosition(),d(["timeupdate"])},250)}),s.paused=i.subscribe("paused",function(){o=!0,p=!1,d(["paused"])}),s.finishedPlaying=i.subscribe("finishedPlaying",function(){o=!0,p=!0,x=setInterval(function(){i.getCurrentPosition(),d(["timeupdate","ended"])},250),clearInterval(x),x=null}),s.startedBuffering=i.subscribe("startedBuffering",function(){d(["progress","timeupdate"])}),s.finishedBuffering=i.subscribe("finishedBuffering",function(){d(["progress","timeupdate"])})}()})},function(a,b,c){var d=void 0,e=a.getElementsByTagName(b)[0];a.getElementById(c)||(d=a.createElement(b),d.id=c,d.src="//connect.facebook.net/en_US/sdk.js",e.parentNode.insertBefore(d,e))}(h["default"],"script","facebook-jssdk")}var g={},i=null,k=null,n=[],o=!0,p=!1,q=!1,r="",s={},t=void 0,u=void 0;b=Object.assign(b,a.options),g.options=b,g.id=a.id+"_"+b.prefix,g.mediaElement=a;var v=j["default"].html5media.properties,w=function(c){var d=""+c.substring(0,1).toUpperCase()+c.substring(1);g["get"+d]=function(){if(null!==i){var a=null;switch(c){case"currentTime":return i.getCurrentPosition();case"duration":return i.getDuration();case"volume":return i.getVolume();case"paused":return o;case"ended":return p;case"muted":return i.isMuted();case"buffered":return{start:function(){return 0},end:function(){return 0},length:1};case"src":return r}return a}return null},g["set"+d]=function(d){if(null!==i)switch(c){case"src":var f="string"==typeof d?d:d[0].src;k.parentNode.removeChild(k),e(f,b.facebook),FB.XFBML.parse();break;case"currentTime":i.seek(d);break;case"muted":d?i.mute():i.unmute(),setTimeout(function(){var b=m.createEvent("volumechange",g);a.dispatchEvent(b)},50);break;case"volume":i.setVolume(d),setTimeout(function(){var b=m.createEvent("volumechange",g);a.dispatchEvent(b)},50)}else n.push({type:"set",propName:c,value:d})}};for(t=0,u=v.length;u>t;t++)w(v[t]);var x=j["default"].html5media.methods,y=function(a){g[a]=function(){if(null!==i)switch(a){case"play":return i.play();case"pause":return i.pause();case"load":return null}else n.push({type:"call",methodName:a})}};for(t=0,u=x.length;u>t;t++)y(x[t]);return c.length>0&&e(c[0].src,g.options.facebook),g.hide=function(){g.stopInterval(),g.pause(),k&&(k.style.display="none")},g.show=function(){k&&(k.style.display="")},g.setSize=function(a,b){null===i||isNaN(a)||isNaN(b)||(k.setAttribute("width",a),k.setAttribute("height",b))},g.destroy=function(){},g.interval=null,g.startInterval=function(){g.interval=setInterval(function(){var b=m.createEvent("timeupdate",g);a.dispatchEvent(b)},250)},g.stopInterval=function(){g.interval&&clearInterval(g.interval)},g}};n.typeChecks.push(function(a){return a=a.toLowerCase(),a.includes("//www.facebook")?"video/x-facebook":null}),k.renderer.add(o)},{"../core/mejs":6,"../core/renderer":7,"../utils/dom":20,"../utils/general":21,"../utils/media":22,"global/document":2,"global/window":3}],12:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}Object.defineProperty(c,"__esModule",{value:!0}),c.PluginDetector=void 0;var e="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(a){return typeof a}:function(a){return a&&"function"==typeof Symbol&&a.constructor===Symbol&&a!==Symbol.prototype?"symbol":typeof a},f=a("global/window"),g=d(f),h=a("global/document"),i=d(h),j=a("../core/mejs"),k=d(j),l=a("../core/i18n"),m=d(l),n=a("../core/renderer"),o=a("../utils/dom"),p=a("../utils/constants"),q=a("../utils/media"),r=c.PluginDetector={plugins:[],hasPluginVersion:function(a,b){var c=r.plugins[a];return b[1]=b[1]||0,b[2]=b[2]||0,c[0]>b[0]||c[0]===b[0]&&c[1]>b[1]||c[0]===b[0]&&c[1]===b[1]&&c[2]>=b[2]},addPlugin:function(a,b,c,d,e){r.plugins[a]=r.detectPlugin(b,c,d,e)},detectPlugin:function(a,b,c,d){var f=[0,0,0],h=void 0,i=void 0;if(void 0!==p.NAV.plugins&&"object"===e(p.NAV.plugins[a])){if(h=p.NAV.plugins[a].description,h&&("undefined"==typeof p.NAV.mimeTypes||!p.NAV.mimeTypes[b]||p.NAV.mimeTypes[b].enabledPlugin)){f=h.replace(a,"").replace(/^\s+/,"").replace(/\sr/gi,".").split(".");for(var j=0;j<f.length;j++)f[j]=parseInt(f[j].match(/\d+/),10)}}else if(void 0!==g["default"].ActiveXObject)try{i=new ActiveXObject(c),i&&(f=d(i))}catch(k){}return f}};r.addPlugin("flash","Shockwave Flash","application/x-shockwave-flash","ShockwaveFlash.ShockwaveFlash",function(a){var b=[],c=a.GetVariable("$version");return c&&(c=c.split(" ")[1].split(","),b=[parseInt(c[0],10),parseInt(c[1],10),parseInt(c[2],10)]),b});var s={create:function(a,b,c){var d={},f=void 0,h=void 0;d.options=b,d.id=a.id+"_"+d.options.prefix,d.mediaElement=a,d.flashState={},d.flashApi=null,d.flashApiStack=[];var j=k["default"].html5media.properties,l=function(a){d.flashState[a]=null;var b=""+a.substring(0,1).toUpperCase()+a.substring(1);d["get"+b]=function(){if(null===d.flashApi)return null;if(void 0===d.flashApi["get_"+a])return null;var b=function(){var b=d.flashApi["get_"+a]();return"buffered"===a?{v:{start:function(){return 0},end:function(){return b},length:1}}:{v:b}}();return"object"===("undefined"==typeof b?"undefined":e(b))?b.v:void 0},d["set"+b]=function(b){"src"===a&&(b=q.absolutizeUrl(b)),null!==d.flashApi&&void 0!==d.flashApi["set_"+a]?d.flashApi["set_"+a](b):d.flashApiStack.push({type:"set",propName:a,value:b})}};for(f=0,h=j.length;h>f;f++)l(j[f]);var r=k["default"].html5media.methods,s=function(a){d[a]=function(){if(null!==d.flashApi){if(d.flashApi["fire_"+a])try{d.flashApi["fire_"+a]()}catch(b){}}else d.flashApiStack.push({type:"call",methodName:a})}};for(r.push("stop"),f=0,h=r.length;h>f;f++)s(r[f]);g["default"]["__ready__"+d.id]=function(){d.flashReady=!0,d.flashApi=i["default"].getElementById("__"+d.id);var b=o.createEvent("rendererready",d);if(a.dispatchEvent(b),d.flashApiStack.length)for(var c=0,e=d.flashApiStack.length;e>c;c++){var f=d.flashApiStack[c];if("set"===f.type){var g=f.propName,h=""+g.substring(0,1).toUpperCase()+g.substring(1);d["set"+h](f.value)}else"call"===f.type&&d[f.methodName]()}},g["default"]["__event__"+d.id]=function(a,b){var c=o.createEvent(a,d);c.message=b||"",d.mediaElement.dispatchEvent(c)},d.flashWrapper=i["default"].createElement("div");var t=!!a.getAttribute("autoplay"),u=["uid="+d.id,"autoplay="+t],v=null!==a.originalNode&&"video"===a.originalNode.tagName.toLowerCase(),w=v?a.originalNode.height:1,x=v?a.originalNode.width:1;d.options.enablePseudoStreaming===!0&&(u.push("pseudostreamstart="+d.options.pseudoStreamingStartQueryParam),u.push("pseudostreamtype="+d.options.pseudoStreamingType)),a.appendChild(d.flashWrapper),v&&null!==a.originalNode&&(a.originalNode.style.display="none");var y=[];if(p.IS_IE){var z=i["default"].createElement("div");d.flashWrapper.appendChild(z),y=['classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"','codebase="//download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab"','id="__'+d.id+'"','width="'+x+'"','height="'+w+'"'],v||y.push('style="clip: rect(0 0 0 0); position: absolute;"'),z.outerHTML="<object "+y.join(" ")+">"+('<param name="movie" value="'+d.options.pluginPath+d.options.filename+"?x="+new Date+'" />')+('<param name="flashvars" value="'+u.join("&amp;")+'" />')+'<param name="quality" value="high" /><param name="bgcolor" value="#000000" /><param name="wmode" value="transparent" /><param name="allowScriptAccess" value="always" /><param name="allowFullScreen" value="true" />'+("<div>"+m["default"].t("mejs.install-flash")+"</div>")+"</object>"}else y=['id="__'+d.id+'"','name="__'+d.id+'"','play="true"','loop="false"','quality="high"','bgcolor="#000000"','wmode="transparent"','allowScriptAccess="always"','allowFullScreen="true"','type="application/x-shockwave-flash"','pluginspage="//www.macromedia.com/go/getflashplayer"','src="'+d.options.pluginPath+d.options.filename+'"','flashvars="'+u.join("&")+'"','width="'+x+'"','height="'+w+'"'],v||y.push('style="clip: rect(0 0 0 0); position: absolute;"'),d.flashWrapper.innerHTML="<embed "+y.join(" ")+">";if(d.flashNode=d.flashWrapper.lastChild,d.hide=function(){if(v){d.flashNode.style.position="absolute",d.flashNode.style.width="1px",d.flashNode.style.height="1px";try{d.flashNode.style.clip="rect(0 0 0 0);"}catch(a){}}},d.show=function(){if(v){d.flashNode.style.position="",d.flashNode.style.width="",d.flashNode.style.height="";try{d.flashNode.style.clip=""}catch(a){}}},d.setSize=function(a,b){d.flashNode.style.width=a+"px",d.flashNode.style.height=b+"px",null!==d.flashApi&&d.flashApi.fire_setSize(a,b)},c&&c.length>0)for(f=0,h=c.length;h>f;f++)if(n.renderer.renderers[b.prefix].canPlayType(c[f].type)){d.setSrc(c[f].src),d.load();break}return d}},t=r.hasPluginVersion("flash",[10,0,0]);if(t){q.typeChecks.push(function(a){return a=a.toLowerCase(),a.startsWith("rtmp")?a.includes(".mp3")?"audio/rtmp":"video/rtmp":a.includes(".oga")||a.includes(".ogg")?"audio/ogg":a.includes(".m3u8")?"application/x-mpegURL":a.includes(".mpd")?"application/dash+xml":null});var u={name:"flash_video",options:{prefix:"flash_video",filename:"mediaelement-flash-video.swf",enablePseudoStreaming:!1,pseudoStreamingStartQueryParam:"start",pseudoStreamingType:"byte"},canPlayType:function(a){return t&&["video/mp4","video/flv","video/rtmp","audio/rtmp","rtmp/mp4","audio/mp4"].includes(a)},create:s.create};n.renderer.add(u);var v={name:"flash_hls",options:{prefix:"flash_hls",filename:"mediaelement-flash-video-hls.swf"},canPlayType:function(a){return t&&["application/x-mpegurl","vnd.apple.mpegurl","audio/mpegurl","audio/hls","video/hls"].includes(a.toLowerCase())},create:s.create};n.renderer.add(v);var w={name:"flash_mdash",options:{prefix:"flash_mdash",filename:"mediaelement-flash-video-mdash.swf"},canPlayType:function(a){return t&&["application/dash+xml"].includes(a)},create:s.create};n.renderer.add(w);var x={name:"flash_audio",options:{prefix:"flash_audio",filename:"mediaelement-flash-audio.swf"},canPlayType:function(a){return t&&["audio/mp3"].includes(a)},create:s.create};n.renderer.add(x);var y={name:"flash_audio_ogg",options:{prefix:"flash_audio_ogg",filename:"mediaelement-flash-audio-ogg.swf"},canPlayType:function(a){return t&&["audio/ogg","audio/oga","audio/ogv"].includes(a)},create:s.create};n.renderer.add(y)}},{"../core/i18n":4,"../core/mejs":6,"../core/renderer":7,"../utils/constants":19,"../utils/dom":20,"../utils/media":22,"global/document":2,"global/window":3}],13:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}var e=a("global/window"),f=d(e),g=a("global/document"),h=d(g),i=a("../core/mejs"),j=d(i),k=a("../core/renderer"),l=a("../utils/dom"),m=a("../utils/constants"),n=a("../utils/media"),o={isMediaStarted:!1,isMediaLoaded:!1,creationQueue:[],prepareSettings:function(a){o.isLoaded?o.createInstance(a):(o.loadScript(a),o.creationQueue.push(a))},loadScript:function(a){o.isMediaStarted||("undefined"!=typeof flvjs?o.createInstance(a):!function(){a.options.path="string"==typeof a.options.path?a.options.path:"//cdnjs.cloudflare.com/ajax/libs/flv.js/1.1.0/flv.min.js";var b=h["default"].createElement("script"),c=h["default"].getElementsByTagName("script")[0],d=!1;b.src=a.options.path,b.onload=b.onreadystatechange=function(){d||this.readyState&&void 0!==this.readyState&&"loaded"!==this.readyState&&"complete"!==this.readyState||(d=!0,o.mediaReady(),b.onload=b.onreadystatechange=null)},c.parentNode.insertBefore(b,c)}(),o.isMediaStarted=!0)},mediaReady:function(){for(o.isLoaded=!0,o.isMediaLoaded=!0;o.creationQueue.length>0;){var a=o.creationQueue.pop();o.createInstance(a)}},createInstance:function(a){var b=flvjs.createPlayer(a.options);f["default"]["__ready__"+a.id](b)}},p={name:"native_flv",options:{prefix:"native_flv",flv:{path:"//cdnjs.cloudflare.com/ajax/libs/flv.js/1.1.0/flv.min.js",cors:!0,enableWorker:!1,enableStashBuffer:!0,stashInitialSize:void 0,isLive:!1,lazyLoad:!0,lazyLoadMaxDuration:180,deferLoadAfterSourceOpen:!0,statisticsInfoReportInterval:600,accurateSeek:!1,seekType:"range",seekParamStart:"bstart",seekParamEnd:"bend",rangeLoadZeroStart:!1,customSeekHandler:void 0}},canPlayType:function(a){return m.HAS_MSE&&["video/x-flv","video/flv"].includes(a)},create:function(a,b,c){var d=null,e=a.originalNode,g=a.id+"_"+b.prefix,i=void 0,m={},n=void 0,p=void 0;d=e.cloneNode(!0),b=Object.assign(b,a.options);var q=j["default"].html5media.properties,r=function(a){var b=""+a.substring(0,1).toUpperCase()+a.substring(1);d["get"+b]=function(){return null!==i?d[a]:null},d["set"+b]=function(b){null!==i?(d[a]=b,"src"===a&&(i.detachMediaElement(),i.attachMediaElement(d),i.load())):m.push({type:"set",propName:a,value:b})}};for(n=0,p=q.length;p>n;n++)r(q[n]);if(f["default"]["__ready__"+g]=function(b){if(a.flvPlayer=i=b,m.length)for(n=0,p=m.length;p>n;n++){var c=m[n];if("set"===c.type){var e=c.propName,f=""+e.substring(0,1).toUpperCase()+e.substring(1);d["set"+f](c.value)}else"call"===c.type&&d[c.methodName]()}var g=j["default"].html5media.events,k=function(b){"loadedmetadata"===b&&(i.detachMediaElement(),i.attachMediaElement(d),i.load()),d.addEventListener(b,function(b){var c=h["default"].createEvent("HTMLEvents");c.initEvent(b.type,b.bubbles,b.cancelable),a.dispatchEvent(c)})};for(g=g.concat(["click","mouseover","mouseout"]),n=0,p=g.length;p>n;n++)k(g[n])},c&&c.length>0)for(n=0,p=c.length;p>n;n++)if(k.renderer.renderers[b.prefix].canPlayType(c[n].type)){d.setAttribute("src",c[n].src);break}d.setAttribute("id",g),e.parentNode.insertBefore(d,e),e.removeAttribute("autoplay"),e.style.display="none",b.flv.type="flv",b.flv.url=d.getAttribute("src"),o.prepareSettings({options:b.flv,id:g}),d.setSize=function(a,b){return d.style.width=a+"px",d.style.height=b+"px",d},d.hide=function(){return d.pause(),d.style.display="none",d},d.show=function(){return d.style.display="",d},d.destroy=function(){i.destroy()};var s=l.createEvent("rendererready",d);return a.dispatchEvent(s),d}};n.typeChecks.push(function(a){return a=a.toLowerCase(),a.includes(".flv")?"video/flv":null}),k.renderer.add(p)},{"../core/mejs":6,"../core/renderer":7,"../utils/constants":19,"../utils/dom":20,"../utils/media":22,"global/document":2,"global/window":3}],14:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}var e=a("global/window"),f=d(e),g=a("global/document"),h=d(g),i=a("../core/mejs"),j=d(i),k=a("../core/renderer"),l=a("../utils/dom"),m=a("../utils/constants"),n=a("../utils/media"),o={isMediaStarted:!1,isMediaLoaded:!1,creationQueue:[],prepareSettings:function(a){o.isLoaded?o.createInstance(a):(o.loadScript(a),o.creationQueue.push(a))},loadScript:function(a){o.isMediaStarted||("undefined"!=typeof Hls?o.createInstance(a):!function(){a.options.path="string"==typeof a.options.path?a.options.path:"//cdn.jsdelivr.net/hls.js/latest/hls.min.js";var b=h["default"].createElement("script"),c=h["default"].getElementsByTagName("script")[0],d=!1;b.src=a.options.path,b.onload=b.onreadystatechange=function(){d||this.readyState&&void 0!==this.readyState&&"loaded"!==this.readyState&&"complete"!==this.readyState||(d=!0,o.mediaReady(),b.onload=b.onreadystatechange=null)},c.parentNode.insertBefore(b,c)}(),o.isMediaStarted=!0)},mediaReady:function(){for(o.isLoaded=!0,o.isMediaLoaded=!0;o.creationQueue.length>0;){var a=o.creationQueue.pop();o.createInstance(a)}},createInstance:function(a){var b=new Hls(a.options);return f["default"]["__ready__"+a.id](b),b}},p={name:"native_hls",options:{prefix:"native_hls",hls:{path:"//cdn.jsdelivr.net/hls.js/latest/hls.min.js",autoStartLoad:!0,startPosition:-1,capLevelToPlayerSize:!1,debug:!1,maxBufferLength:30,maxMaxBufferLength:600,maxBufferSize:6e7,maxBufferHole:.5,maxSeekHole:2,seekHoleNudgeDuration:.01,maxFragLookUpTolerance:.2,liveSyncDurationCount:3,liveMaxLatencyDurationCount:10,enableWorker:!0,enableSoftwareAES:!0,manifestLoadingTimeOut:1e4,manifestLoadingMaxRetry:6,manifestLoadingRetryDelay:500,manifestLoadingMaxRetryTimeout:64e3,levelLoadingTimeOut:1e4,levelLoadingMaxRetry:6,levelLoadingRetryDelay:500,levelLoadingMaxRetryTimeout:64e3,fragLoadingTimeOut:2e4,fragLoadingMaxRetry:6,fragLoadingRetryDelay:500,fragLoadingMaxRetryTimeout:64e3,startFragPrefech:!1,appendErrorMaxRetry:3,enableCEA708Captions:!0,stretchShortVideoTrack:!0,forceKeyFrameOnDiscontinuity:!0,abrEwmaFastLive:5,abrEwmaSlowLive:9,abrEwmaFastVoD:4,abrEwmaSlowVoD:15,abrEwmaDefaultEstimate:5e5,abrBandWidthFactor:.8,abrBandWidthUpFactor:.7}},canPlayType:function(a){return m.HAS_MSE&&["application/x-mpegurl","vnd.apple.mpegurl","audio/mpegurl","audio/hls","video/hls"].includes(a.toLowerCase())},create:function(a,b,c){var d=null,e=a.originalNode,g=a.id+"_"+b.prefix,i=void 0,m={},n=void 0,p=void 0;d=e.cloneNode(!0),b=Object.assign(b,a.options);var q=j["default"].html5media.properties,r=function(a){var c=""+a.substring(0,1).toUpperCase()+a.substring(1);d["get"+c]=function(){return null!==i?d[a]:null},d["set"+c]=function(c){null!==i?(d[a]=c,"src"===a&&(i.destroy(),i=null,i=o.createInstance({options:b.hls,id:g}),i.attachMedia(d),i.on(Hls.Events.MEDIA_ATTACHED,function(){i.loadSource(c)}))):m.push({type:"set",propName:a,value:c})}};for(n=0,p=q.length;p>n;n++)r(q[n]);if(f["default"]["__ready__"+g]=function(b){if(a.hlsPlayer=i=b,m.length)for(n=0,p=m.length;p>n;n++){var c=m[n];if("set"===c.type){var e=c.propName,f=""+e.substring(0,1).toUpperCase()+e.substring(1);d["set"+f](c.value)}else"call"===c.type&&d[c.methodName]()}var g=j["default"].html5media.events,k=Hls.Events,o=function(b){"loadedmetadata"===b&&!function(){i.detachMedia();var a=d.src;i.attachMedia(d),i.on(k.MEDIA_ATTACHED,function(){i.loadSource(a)})}(),d.addEventListener(b,function(b){var c=h["default"].createEvent("HTMLEvents");c.initEvent(b.type,b.bubbles,b.cancelable),a.dispatchEvent(c)})};for(g=g.concat(["click","mouseover","mouseout"]),n=0,p=g.length;p>n;n++)o(g[n]);var q=function(b,c){var e=l.createEvent(b,d);if(e.data=c,a.dispatchEvent(e),
"hlsError"===b)if(console.error(b,c),c.fatal)i.destroy();else switch(c.type){case"mediaError":i.recoverMediaError();break;case"networkError":i.startLoad()}};for(var r in k)k.hasOwnProperty(r)&&i.on(k[r],q)},c&&c.length>0)for(n=0,p=c.length;p>n;n++)if(k.renderer.renderers[b.prefix].canPlayType(c[n].type)){d.setAttribute("src",c[n].src);break}d.setAttribute("id",g),e.parentNode.insertBefore(d,e),e.removeAttribute("autoplay"),e.style.display="none",o.prepareSettings({options:b.hls,id:g}),d.setSize=function(a,b){return d.style.width=a+"px",d.style.height=b+"px",d},d.hide=function(){return d.pause(),d.style.display="none",d},d.show=function(){return d.style.display="",d},d.destroy=function(){i.destroy()};var s=l.createEvent("rendererready",d);return a.dispatchEvent(s),d}};n.typeChecks.push(function(a){return a=a.toLowerCase(),a.includes(".m3u8")?"application/x-mpegURL":null}),k.renderer.add(p)},{"../core/mejs":6,"../core/renderer":7,"../utils/constants":19,"../utils/dom":20,"../utils/media":22,"global/document":2,"global/window":3}],15:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}var e=a("global/window"),f=d(e),g=a("global/document"),h=d(g),i=a("../core/mejs"),j=d(i),k=a("../core/renderer"),l=a("../utils/dom"),m=a("../utils/constants"),n={name:"html5",options:{prefix:"html5"},canPlayType:function(a){var b=h["default"].createElement("video");return m.IS_ANDROID&&null!==a.match(/\/mp(3|4)$/gi)||m.SUPPORTS_NATIVE_HLS?"yes":b.canPlayType?b.canPlayType(a).replace(/no/,""):""},create:function(a,b,c){var d=null,e=a.id+"_"+b.prefix,f=void 0,g=void 0;void 0===a.originalNode||null===a.originalNode?(d=h["default"].createElement("audio"),a.appendChild(d)):d=a.originalNode,d.setAttribute("id",e);var i=j["default"].html5media.properties,m=function(a){var b=""+a.substring(0,1).toUpperCase()+a.substring(1);d["get"+b]=function(){return d[a]},d["set"+b]=function(b){d[a]=b}};for(f=0,g=i.length;g>f;f++)m(i[f]);var n=j["default"].html5media.events.concat(["click","mouseover","mouseout"]),o=function(b){d.addEventListener(b,function(b){var c=h["default"].createEvent("HTMLEvents");c.initEvent(b.type,b.bubbles,b.cancelable),a.dispatchEvent(c)})};for(f=0,g=n.length;g>f;f++)o(n[f]);if(d.setSize=function(a,b){return d.style.width=a+"px",d.style.height=b+"px",d},d.hide=function(){return d.style.display="none",d},d.show=function(){return d.style.display="",d},c&&c.length>0)for(f=0,g=c.length;g>f;f++)if(k.renderer.renderers[b.prefix].canPlayType(c[f].type)){d.setAttribute("src",c[f].src);break}var p=l.createEvent("rendererready",d);return a.dispatchEvent(p),d}};f["default"].HtmlMediaElement=j["default"].HtmlMediaElement=n,k.renderer.add(n)},{"../core/mejs":6,"../core/renderer":7,"../utils/constants":19,"../utils/dom":20,"global/document":2,"global/window":3}],16:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}var e=a("global/window"),f=d(e),g=a("global/document"),h=d(g),i=a("../core/mejs"),j=d(i),k=a("../core/renderer"),l=a("../utils/dom"),m=a("../utils/media"),n={isSDKStarted:!1,isSDKLoaded:!1,iframeQueue:[],enqueueIframe:function(a){n.isLoaded?n.createIframe(a):(n.loadIframeApi(),n.iframeQueue.push(a))},loadIframeApi:function(){n.isSDKStarted||!function(){var a=h["default"].getElementsByTagName("head")[0]||h["default"].documentElement,b=h["default"].createElement("script"),c=!1;b.src="//w.soundcloud.com/player/api.js",b.onload=b.onreadystatechange=function(){c||n.readyState&&"loaded"!==n.readyState&&"complete"!==n.readyState||(c=!0,n.apiReady(),b.onload=b.onreadystatechange=null,a&&b.parentNode&&a.removeChild(b))},a.appendChild(b),n.isSDKStarted=!0}()},apiReady:function(){for(n.isLoaded=!0,n.isSDKLoaded=!0;n.iframeQueue.length>0;){var a=n.iframeQueue.pop();n.createIframe(a)}},createIframe:function(a){var b=SC.Widget(a.iframe);f["default"]["__ready__"+a.id](b)}},o={name:"soundcloud_iframe",options:{prefix:"soundcloud_iframe"},canPlayType:function(a){return["video/soundcloud","video/x-soundcloud"].includes(a)},create:function(a,b,c){var d={};d.options=b,d.id=a.id+"_"+b.prefix,d.mediaElement=a;var e=[],g=!1,i=null,k=null,m=0,o=0,p=0,q=!0,r=1,s=!1,t=!1,u=void 0,v=void 0,w=j["default"].html5media.properties,x=function(b){var c=""+b.substring(0,1).toUpperCase()+b.substring(1);d["get"+c]=function(){if(null!==i){var a=null;switch(b){case"currentTime":return m;case"duration":return o;case"volume":return r;case"paused":return q;case"ended":return t;case"muted":return s;case"buffered":return{start:function(){return 0},end:function(){return p*o},length:1};case"src":return k?k.src:""}return a}return null},d["set"+c]=function(c){if(null!==i)switch(b){case"src":var f="string"==typeof c?c:c[0].src;i.load(f);break;case"currentTime":i.seekTo(1e3*c);break;case"muted":c?i.setVolume(0):i.setVolume(1),setTimeout(function(){var b=l.createEvent("volumechange",d);a.dispatchEvent(b)},50);break;case"volume":i.setVolume(c),setTimeout(function(){var b=l.createEvent("volumechange",d);a.dispatchEvent(b)},50)}else e.push({type:"set",propName:b,value:c})}};for(u=0,v=w.length;v>u;u++)x(w[u]);var y=j["default"].html5media.methods,z=function(a){d[a]=function(){if(null!==i)switch(a){case"play":return i.play();case"pause":return i.pause();case"load":return null}else e.push({type:"call",methodName:a})}};for(u=0,v=y.length;v>u;u++)z(y[u]);f["default"]["__ready__"+d.id]=function(b){if(g=!0,a.scPlayer=i=b,e.length)for(u=0,v=e.length;v>u;u++){var c=e[u];if("set"===c.type){var f=c.propName,h=""+f.substring(0,1).toUpperCase()+f.substring(1);d["set"+h](c.value)}else"call"===c.type&&d[c.methodName]()}i.bind(SC.Widget.Events.PLAY_PROGRESS,function(){q=!1,t=!1,i.getPosition(function(b){m=b/1e3;var c=l.createEvent("timeupdate",d);a.dispatchEvent(c)})}),i.bind(SC.Widget.Events.PAUSE,function(){q=!0;var b=l.createEvent("pause",d);a.dispatchEvent(b)}),i.bind(SC.Widget.Events.PLAY,function(){q=!1,t=!1;var b=l.createEvent("play",d);a.dispatchEvent(b)}),i.bind(SC.Widget.Events.FINISHED,function(){q=!1,t=!0;var b=l.createEvent("ended",d);a.dispatchEvent(b)}),i.bind(SC.Widget.Events.READY,function(){i.getDuration(function(b){o=b/1e3;var c=l.createEvent("loadedmetadata",d);a.dispatchEvent(c)})}),i.bind(SC.Widget.Events.LOAD_PROGRESS,function(){i.getDuration(function(b){if(o>0){p=o*b;var c=l.createEvent("progress",d);a.dispatchEvent(c)}}),i.getDuration(function(b){o=b;var c=l.createEvent("loadedmetadata",d);a.dispatchEvent(c)})});for(var j=["rendererready","loadeddata","loadedmetadata","canplay"],k=0,n=j.length;n>k;k++){var r=l.createEvent(j[k],d);a.dispatchEvent(r)}},k=h["default"].createElement("iframe"),k.id=d.id,k.width=10,k.height=10,k.frameBorder=0,k.style.visibility="hidden",k.src=c[0].src,k.scrolling="no",a.appendChild(k),a.originalNode.style.display="none";var A={iframe:k,id:d.id};return n.enqueueIframe(A),d.setSize=function(a,b){},d.hide=function(){d.pause(),k&&(k.style.display="none")},d.show=function(){k&&(k.style.display="")},d.destroy=function(){i.destroy()},d}};m.typeChecks.push(function(a){return a=a.toLowerCase(),a.includes("//soundcloud.com")||a.includes("//w.soundcloud.com")?"video/x-soundcloud":null}),k.renderer.add(o)},{"../core/mejs":6,"../core/renderer":7,"../utils/dom":20,"../utils/media":22,"global/document":2,"global/window":3}],17:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}var e=a("global/window"),f=d(e),g=a("global/document"),h=d(g),i=a("../core/mejs"),j=d(i),k=a("../core/renderer"),l=a("../utils/dom"),m=a("../utils/media"),n={isIframeStarted:!1,isIframeLoaded:!1,iframeQueue:[],enqueueIframe:function(a){n.isLoaded?n.createIframe(a):(n.loadIframeApi(),n.iframeQueue.push(a))},loadIframeApi:function(){n.isIframeStarted||!function(){var a=h["default"].createElement("script"),b=h["default"].getElementsByTagName("script")[0],c=!1;a.src="//player.vimeo.com/api/player.js",a.onload=a.onreadystatechange=function(){c||n.readyState&&void 0!==n.readyState&&"loaded"!==n.readyState&&"complete"!==n.readyState||(c=!0,n.iFrameReady(),a.onload=a.onreadystatechange=null)},b.parentNode.insertBefore(a,b),n.isIframeStarted=!0}()},iFrameReady:function(){for(n.isLoaded=!0,n.isIframeLoaded=!0;n.iframeQueue.length>0;){var a=n.iframeQueue.pop();n.createIframe(a)}},createIframe:function(a){var b=new Vimeo.Player(a.iframe);f["default"]["__ready__"+a.id](b)},getVimeoId:function(a){if(void 0===a||null===a)return null;var b=a.split("?");return a=b[0],parseInt(a.substring(a.lastIndexOf("/")+1))},errorHandler:function(a,b){var c=l.createEvent("error",b);c.message=a.name+": "+a.message,mediaElement.dispatchEvent(c)}},o={name:"vimeo_iframe",options:{prefix:"vimeo_iframe"},canPlayType:function(a){return["video/vimeo","video/x-vimeo"].includes(a)},create:function(a,b,c){var d=[],e=!1,g={},i=null,k=!0,m=1,o=m,p=0,q=0,r=!1,s=0,t="",u=void 0,v=void 0;g.options=b,g.id=a.id+"_"+b.prefix,g.mediaElement=a;var w=j["default"].html5media.properties,x=function(b){var c=""+b.substring(0,1).toUpperCase()+b.substring(1);g["get"+c]=function(){if(null!==i){var a=null;switch(b){case"currentTime":return p;case"duration":return s;case"volume":return m;case"muted":return 0===m;case"paused":return k;case"ended":return r;case"src":return i.getVideoUrl().then(function(a){t=a}),t;case"buffered":return{start:function(){return 0},end:function(){return q*s},length:1}}return a}return null},g["set"+c]=function(c){if(null!==i)switch(b){case"src":var e="string"==typeof c?c:c[0].src,f=n.getVimeoId(e);i.loadVideo(f).then(function(){a.getAttribute("autoplay")&&i.play()})["catch"](function(a){n.errorHandler(a,g)});break;case"currentTime":i.setCurrentTime(c).then(function(){p=c,setTimeout(function(){var b=l.createEvent("timeupdate",g);a.dispatchEvent(b)},50)})["catch"](function(a){n.errorHandler(a,g)});break;case"volume":i.setVolume(c).then(function(){m=c,o=m,setTimeout(function(){var b=l.createEvent("volumechange",g);a.dispatchEvent(b)},50)})["catch"](function(a){n.errorHandler(a,g)});break;case"loop":i.setLoop(c)["catch"](function(a){n.errorHandler(a,g)});break;case"muted":c?i.setVolume(0).then(function(){m=0,setTimeout(function(){var b=l.createEvent("volumechange",g);a.dispatchEvent(b)},50)})["catch"](function(a){n.errorHandler(a,g)}):i.setVolume(o).then(function(){m=o,setTimeout(function(){var b=l.createEvent("volumechange",g);a.dispatchEvent(b)},50)})["catch"](function(a){n.errorHandler(a,g)})}else d.push({type:"set",propName:b,value:c})}};for(u=0,v=w.length;v>u;u++)x(w[u]);var y=j["default"].html5media.methods,z=function(a){g[a]=function(){if(null!==i)switch(a){case"play":return i.play();case"pause":return i.pause();case"load":return null}else d.push({type:"call",methodName:a})}};for(u=0,v=y.length;v>u;u++)z(y[u]);f["default"]["__ready__"+g.id]=function(b){if(e=!0,a.vimeoPlayer=i=b,d.length)for(u=0,v=d.length;v>u;u++){var c=d[u];if("set"===c.type){var f=c.propName,j=""+f.substring(0,1).toUpperCase()+f.substring(1);g["set"+j](c.value)}else"call"===c.type&&g[c.methodName]()}var m=h["default"].getElementById(g.id),o=void 0;o=["mouseover","mouseout"];var t=function(b){var c=l.createEvent(b.type,g);a.dispatchEvent(c)};for(var w in o){var x=o[w];l.addEvent(m,x,t)}for(i.on("loaded",function(){i.getDuration().then(function(b){s=b,s>0&&(q=s*b);var c=l.createEvent("loadedmetadata",g);a.dispatchEvent(c)})["catch"](function(a){n.errorHandler(a,g)})}),i.on("progress",function(){k=g.mediaElement.getPaused(),i.getDuration().then(function(b){s=b,s>0&&(q=s*b);var c=l.createEvent("progress",g);a.dispatchEvent(c)})["catch"](function(a){n.errorHandler(a,g)})}),i.on("timeupdate",function(){k=g.mediaElement.getPaused(),r=!1,i.getCurrentTime().then(function(a){p=a});var b=l.createEvent("timeupdate",g);a.dispatchEvent(b)}),i.on("play",function(){k=!1,r=!1,i.play()["catch"](function(a){n.errorHandler(a,g)});var b=l.createEvent("play",g);a.dispatchEvent(b)}),i.on("pause",function(){k=!0,r=!1,i.pause()["catch"](function(a){n.errorHandler(a,g)});var b=l.createEvent("pause",g);a.dispatchEvent(b)}),i.on("ended",function(){k=!1,r=!0;var b=l.createEvent("ended",g);a.dispatchEvent(b)}),o=["rendererready","loadeddata","loadedmetadata","canplay"],u=0,v=o.length;v>u;u++){var y=l.createEvent(o[u],g);a.dispatchEvent(y)}};var A=a.originalNode.height,B=a.originalNode.width,C=h["default"].createElement("iframe"),D="//player.vimeo.com/video/"+n.getVimeoId(c[0].src);return C.setAttribute("id",g.id),C.setAttribute("width",B),C.setAttribute("height",A),C.setAttribute("frameBorder","0"),C.setAttribute("src",D),C.setAttribute("webkitallowfullscreen",""),C.setAttribute("mozallowfullscreen",""),C.setAttribute("allowfullscreen",""),a.originalNode.parentNode.insertBefore(C,a.originalNode),a.originalNode.style.display="none",n.enqueueIframe({iframe:C,id:g.id}),g.hide=function(){g.pause(),i&&(C.style.display="none")},g.setSize=function(a,b){C.setAttribute("width",a),C.setAttribute("height",b)},g.show=function(){i&&(C.style.display="")},g}};m.typeChecks.push(function(a){return a=a.toLowerCase(),a.includes("//player.vimeo")||a.includes("vimeo.com")?"video/x-vimeo":null}),k.renderer.add(o)},{"../core/mejs":6,"../core/renderer":7,"../utils/dom":20,"../utils/media":22,"global/document":2,"global/window":3}],18:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}var e="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(a){return typeof a}:function(a){return a&&"function"==typeof Symbol&&a.constructor===Symbol&&a!==Symbol.prototype?"symbol":typeof a},f=a("global/window"),g=d(f),h=a("global/document"),i=d(h),j=a("../core/mejs"),k=d(j),l=a("../core/renderer"),m=a("../utils/dom"),n=a("../utils/media"),o={isIframeStarted:!1,isIframeLoaded:!1,iframeQueue:[],enqueueIframe:function(a){o.isLoaded?o.createIframe(a):(o.loadIframeApi(),o.iframeQueue.push(a))},loadIframeApi:function(){if(!o.isIframeStarted){var a=i["default"].createElement("script");a.src="//www.youtube.com/player_api";var b=i["default"].getElementsByTagName("script")[0];b.parentNode.insertBefore(a,b),o.isIframeStarted=!0}},iFrameReady:function(){for(o.isLoaded=!0,o.isIframeLoaded=!0;o.iframeQueue.length>0;){var a=o.iframeQueue.pop();o.createIframe(a)}},createIframe:function(a){return new YT.Player(a.containerId,a)},getYouTubeId:function(a){var b="";return a.indexOf("?")>0?(b=o.getYouTubeIdFromParam(a),""===b&&(b=o.getYouTubeIdFromUrl(a))):b=o.getYouTubeIdFromUrl(a),b},getYouTubeIdFromParam:function(a){if(void 0===a||null===a||!a.trim().length)return null;for(var b="",c=a.split("?"),d=c[1].split("&"),e=0,f=d.length;f>e;e++){var g=d[e].split("=");if("v"===g[0]){b=g[1];break}}return b},getYouTubeIdFromUrl:function(a){if(void 0===a||null===a||!a.trim().length)return null;var b=a.split("?");return a=b[0],a.substring(a.lastIndexOf("/")+1)},getYouTubeNoCookieUrl:function(a){if(void 0===a||null===a||!a.trim().length||!a.includes("//www.youtube"))return a;var b=a.split("/");return b[2]=b[2].replace(".com","-nocookie.com"),b.join("/")}},p={name:"youtube_iframe",options:{prefix:"youtube_iframe",youtube:{autoplay:0,controls:0,disablekb:1,end:0,loop:0,modestbranding:0,playsinline:0,rel:0,showinfo:0,start:0,nocookie:!0}},canPlayType:function(a){return["video/youtube","video/x-youtube"].includes(a)},create:function(a,b,c){var d={};d.options=b,d.id=a.id+"_"+b.prefix,d.mediaElement=a;var f=[],h=null,j=!1,l=!0,n=!1,p=null,q=void 0,r=void 0,s=k["default"].html5media.properties,t=function(b){var c=""+b.substring(0,1).toUpperCase()+b.substring(1);d["get"+c]=function(){if(null!==h){var a=null,c=function(){switch(b){case"currentTime":return{v:h.getCurrentTime()};case"duration":return{v:h.getDuration()};case"volume":return{v:h.getVolume()};case"paused":return{v:l};case"ended":return{v:n};case"muted":return{v:h.isMuted()};case"buffered":var a=h.getVideoLoadedFraction(),c=h.getDuration();return{v:{start:function(){return 0},end:function(){return a*c},length:1}};case"src":return{v:h.getVideoUrl()}}}();return"object"===("undefined"==typeof c?"undefined":e(c))?c.v:a}return null},d["set"+c]=function(c){if(null!==h)switch(b){case"src":var e="string"==typeof c?c:c[0].src,g=o.getYouTubeId(e);a.getAttribute("autoplay")?h.loadVideoById(g):h.cueVideoById(g);break;case"currentTime":h.seekTo(c);break;case"muted":c?h.mute():h.unMute(),setTimeout(function(){var b=m.createEvent("volumechange",d);a.dispatchEvent(b)},50);break;case"volume":h.setVolume(c),setTimeout(function(){var b=m.createEvent("volumechange",d);a.dispatchEvent(b)},50)}else f.push({type:"set",propName:b,value:c})}};for(q=0,r=s.length;r>q;q++)t(s[q]);var u=k["default"].html5media.methods,v=function(a){d[a]=function(){if(null!==h)switch(a){case"play":return h.playVideo();case"pause":return h.pauseVideo();case"load":return null}else f.push({type:"call",methodName:a})}};for(q=0,r=u.length;r>q;q++)v(u[q]);var w=i["default"].createElement("div");w.id=d.id,d.options.youtube.nocookie&&a.originalNode.setAttribute("src",o.getYouTubeNoCookieUrl(c[0].src)),a.originalNode.parentNode.insertBefore(w,a.originalNode),a.originalNode.style.display="none";var x=a.originalNode.height,y=a.originalNode.width,z=o.getYouTubeId(c[0].src),A={id:d.id,containerId:w.id,videoId:z,height:x,width:y,playerVars:Object.assign({controls:0,rel:0,disablekb:1,showinfo:0,modestbranding:0,html5:1,playsinline:0,start:0,end:0},d.options.youtube),origin:g["default"].location.host,events:{onReady:function(b){if(j=!0,a.youTubeApi=h=b.target,a.youTubeState={paused:!0,ended:!1},f.length)for(q=0,r=f.length;r>q;q++){var c=f[q];if("set"===c.type){var e=c.propName,g=""+e.substring(0,1).toUpperCase()+e.substring(1);d["set"+g](c.value)}else"call"===c.type&&d[c.methodName]()}p=h.getIframe();var i=["mouseover","mouseout"],k=function(b){var c=m.createEvent(b.type,d);a.dispatchEvent(c)};for(var l in i)m.addEvent(p,i[l],k);var n=["rendererready","loadeddata","loadedmetadata","canplay"];for(q=0,r=n.length;r>q;q++){var o=m.createEvent(n[q],d);a.dispatchEvent(o)}},onStateChange:function(b){var c=[];switch(b.data){case-1:c=["loadedmetadata"],l=!0,n=!1;break;case 0:c=["ended"],l=!1,n=!0,d.stopInterval();break;case 1:c=["play","playing"],l=!1,n=!1,d.startInterval();break;case 2:c=["paused"],l=!0,n=!1,d.stopInterval();break;case 3:c=["progress"],l=!1,n=!1;break;case 5:c=["loadeddata","loadedmetadata","canplay"],l=!0,n=!1}for(var e=0,f=c.length;f>e;e++){var g=m.createEvent(c[e],d);a.dispatchEvent(g)}}}};return o.enqueueIframe(A),d.onEvent=function(b,c,d){null!==d&&void 0!==d&&(a.youTubeState=d)},d.setSize=function(a,b){null!==h&&h.setSize(a,b)},d.hide=function(){d.stopInterval(),d.pause(),p&&(p.style.display="none")},d.show=function(){p&&(p.style.display="")},d.destroy=function(){h.destroy()},d.interval=null,d.startInterval=function(){d.interval=setInterval(function(){var b=m.createEvent("timeupdate",d);a.dispatchEvent(b)},250)},d.stopInterval=function(){d.interval&&clearInterval(d.interval)},d}};g["default"].postMessage&&e(g["default"].addEventListener)&&(g["default"].onYouTubePlayerAPIReady=function(){o.iFrameReady()},n.typeChecks.push(function(a){return a=a.toLowerCase(),a.includes("//www.youtube")||a.includes("//youtu.be")?"video/x-youtube":null}),l.renderer.add(p))},{"../core/mejs":6,"../core/renderer":7,"../utils/dom":20,"../utils/media":22,"global/document":2,"global/window":3}],19:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}Object.defineProperty(c,"__esModule",{value:!0}),c.cancelFullScreen=c.requestFullScreen=c.isFullScreen=c.FULLSCREEN_EVENT_NAME=c.HAS_NATIVE_FULLSCREEN_ENABLED=c.HAS_TRUE_NATIVE_FULLSCREEN=c.HAS_IOS_FULLSCREEN=c.HAS_MS_NATIVE_FULLSCREEN=c.HAS_MOZ_NATIVE_FULLSCREEN=c.HAS_WEBKIT_NATIVE_FULLSCREEN=c.HAS_NATIVE_FULLSCREEN=c.SUPPORTS_NATIVE_HLS=c.SUPPORTS_MEDIA_TAG=c.SUPPORT_POINTER_EVENTS=c.HAS_MSE=c.HAS_TOUCH=c.IS_STOCK_ANDROID=c.IS_SAFARI=c.IS_FIREFOX=c.IS_CHROME=c.IS_IE=c.IS_ANDROID=c.IS_IOS=c.IS_IPHONE=c.IS_IPAD=c.UA=c.NAV=void 0;for(var e=a("global/window"),f=d(e),g=a("global/document"),h=d(g),i=a("../core/mejs"),j=d(i),k=c.NAV=f["default"].navigator,l=c.UA=k.userAgent.toLowerCase(),m=c.IS_IPAD=null!==l.match(/ipad/i),n=c.IS_IPHONE=null!==l.match(/iphone/i),o=(c.IS_IOS=n||m,c.IS_ANDROID=null!==l.match(/android/i)),p=c.IS_IE=k.appName.toLowerCase().includes("microsoft")||null!==k.appName.toLowerCase().match(/trident/gi),q=c.IS_CHROME=null!==l.match(/chrome/gi),r=c.IS_FIREFOX=null!==l.match(/firefox/gi),s=c.IS_SAFARI=null!==l.match(/safari/gi)&&!q,t=c.IS_STOCK_ANDROID=null!==l.match(/^mozilla\/\d+\.\d+\s\(linux;\su;/gi),u=(c.HAS_TOUCH=!!("ontouchstart"in f["default"]||f["default"].DocumentTouch&&h["default"]instanceof f["default"].DocumentTouch)),v=(c.HAS_MSE="MediaSource"in f["default"]),w=(c.SUPPORT_POINTER_EVENTS=function(){var a=h["default"].createElement("x"),b=h["default"].documentElement,c=f["default"].getComputedStyle,d=void 0;return"pointerEvents"in a.style?(a.style.pointerEvents="auto",a.style.pointerEvents="x",b.appendChild(a),d=c&&"auto"===c(a,"").pointerEvents,b.removeChild(a),!!d):!1}()),x=["source","track","audio","video"],y=void 0,z=0,A=x.length;A>z;z++)y=h["default"].createElement(x[z]);var B=c.SUPPORTS_MEDIA_TAG=void 0!==y.canPlayType||v,C=c.SUPPORTS_NATIVE_HLS=s||o&&(q||t)||p&&null!==l.match(/edge/gi),D=void 0!==y.webkitEnterFullscreen,E=void 0!==y.requestFullscreen;D&&l.match(/mac os x 10_5/i)&&(E=!1,D=!1);var F=void 0!==y.webkitRequestFullScreen,G=void 0!==y.mozRequestFullScreen,H=void 0!==y.msRequestFullscreen,I=F||G||H,J=I,K="",L=void 0,M=void 0,N=void 0;G?J=h["default"].mozFullScreenEnabled:H&&(J=h["default"].msFullscreenEnabled),q&&(D=!1),I&&(F?K="webkitfullscreenchange":G?K="mozfullscreenchange":H&&(K="MSFullscreenChange"),c.isFullScreen=L=function(){return G?h["default"].mozFullScreen:F?h["default"].webkitIsFullScreen:H?null!==h["default"].msFullscreenElement:void 0},c.requestFullScreen=M=function(a){F?a.webkitRequestFullScreen():G?a.mozRequestFullScreen():H&&a.msRequestFullscreen()},c.cancelFullScreen=N=function(){F?h["default"].webkitCancelFullScreen():G?h["default"].mozCancelFullScreen():H&&h["default"].msExitFullscreen()});var O=c.HAS_NATIVE_FULLSCREEN=E,P=c.HAS_WEBKIT_NATIVE_FULLSCREEN=F,Q=c.HAS_MOZ_NATIVE_FULLSCREEN=G,R=c.HAS_MS_NATIVE_FULLSCREEN=H,S=c.HAS_IOS_FULLSCREEN=D,T=c.HAS_TRUE_NATIVE_FULLSCREEN=I,U=c.HAS_NATIVE_FULLSCREEN_ENABLED=J,V=c.FULLSCREEN_EVENT_NAME=K;c.isFullScreen=L,c.requestFullScreen=M,c.cancelFullScreen=N,j["default"].Features=j["default"].Features||{},j["default"].Features.isiPad=m,j["default"].Features.isiPhone=n,j["default"].Features.isiOS=j["default"].Features.isiPhone||j["default"].Features.isiPad,j["default"].Features.isAndroid=o,j["default"].Features.isIE=p,j["default"].Features.isChrome=q,j["default"].Features.isFirefox=r,j["default"].Features.isSafari=s,j["default"].Features.isStockAndroid=t,j["default"].Features.hasTouch=u,j["default"].Features.hasMSE=v,j["default"].Features.supportsMediaTag=B,j["default"].Features.supportsNativeHLS=C,j["default"].Features.supportsPointerEvents=w,j["default"].Features.hasiOSFullScreen=S,j["default"].Features.hasNativeFullscreen=O,j["default"].Features.hasWebkitNativeFullScreen=P,j["default"].Features.hasMozNativeFullScreen=Q,j["default"].Features.hasMsNativeFullScreen=R,j["default"].Features.hasTrueNativeFullScreen=T,j["default"].Features.nativeFullScreenEnabled=U,j["default"].Features.fullScreenEventName=V,j["default"].Features.isFullScreen=L,j["default"].Features.requestFullScreen=M,j["default"].Features.cancelFullScreen=N},{"../core/mejs":6,"global/document":2,"global/window":3}],20:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}function e(a,b){if("string"!=typeof a)throw new Error("Event name must be a string");var c=void 0;return j["default"].createEvent?(c=j["default"].createEvent("Event"),c.initEvent(a,!0,!1)):(c={},c.type=a,c.target=b,c.canceleable=!0,c.bubbable=!1),c}function f(a,b,c){a.addEventListener?a.addEventListener(b,c,!1):a.attachEvent&&(a["e"+b+c]=c,a[""+b+c]=function(){a["e"+b+c](window.event)},a.attachEvent("on"+b,a[""+b+c]))}function g(a,b,c){a.removeEventListener?a.removeEventListener(b,c,!1):a.detachEvent&&(a.detachEvent("on"+b,a[""+b+c]),a[""+b+c]=null)}function h(a,b){return!!(a&&b&&a.compareDocumentPosition(b)&&Node.DOCUMENT_POSITION_PRECEDING)}Object.defineProperty(c,"__esModule",{value:!0}),c.createEvent=e,c.addEvent=f,c.removeEvent=g,c.isNodeAfter=h;var i=a("global/document"),j=d(i),k=a("../core/mejs"),l=d(k);l["default"].Utils=l["default"].Utils||{},l["default"].Utils.createEvent=e,l["default"].Utils.removeEvent=g,l["default"].Utils.isNodeAfter=h},{"../core/mejs":6,"global/document":2}],21:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}function e(a){if("string"!=typeof a)throw new Error("Argument passed must be a string");var b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;"};return a.replace(/[&<>"]/g,function(a){return b[a]})}function f(a,b){var c=this,d=arguments,e=arguments.length>2&&void 0!==arguments[2]?arguments[2]:!1;if("function"!=typeof a)throw new Error("First argument must be a function");if("number"!=typeof b)throw new Error("Second argument must be a numeric value");var f=void 0;return function(){var g=c,h=d,i=function(){f=null,e||a.apply(g,h)},j=e&&!f;clearTimeout(f),f=setTimeout(i,b),j&&a.apply(g,h)}}function g(a){return Object.getOwnPropertyNames(a).length<=0}function h(a,b){var c=/^((after|before)print|(before)?unload|hashchange|message|o(ff|n)line|page(hide|show)|popstate|resize|storage)\b/,d={d:[],w:[]};return(a||"").split(" ").forEach(function(a){var e=a+"."+b;e.startsWith(".")?(d.d.push(e),d.w.push(e)):d[c.test(a)?"w":"d"].push(e)}),d.d=d.d.join(" "),d.w=d.w.join(" "),d}function j(a,b,c){if((void 0===b||null===b)&&(b=l["default"]),void 0!==b.getElementsByClassName&&null!==b.getElementsByClassName)return b.getElementsByClassName(a);(void 0===c||null===c)&&(c="*");var d=[],e=0,f=void 0,g=b.getElementsByTagName(c),h=g.length;for(i=0;i<h;i++)g[i].className.indexOf(a)>-1&&(f=","+g[i].className.split(" ").join(",")+",",f.indexOf(","+a+",")>-1&&(d[e]=g[i],e++));return d}Object.defineProperty(c,"__esModule",{value:!0}),c.escapeHTML=e,c.debounce=f,c.isObjectEmpty=g,c.splitEvents=h,c.getElementsByClassName=j;var k=a("global/document"),l=d(k),m=a("../core/mejs"),n=d(m);n["default"].Utils=n["default"].Utils||{},n["default"].Utils.escapeHTML=e,n["default"].Utils.debounce=f,n["default"].Utils.isObjectEmpty=g,n["default"].Utils.splitEvents=h,n["default"].Utils.getElementsByClassName=j},{"../core/mejs":6,"global/document":2}],22:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}function e(a){if("string"!=typeof a)throw new Error("`url` argument must be a string");var b=document.createElement("div");return b.innerHTML='<a href="'+m.escapeHTML(a)+'">x</a>',b.firstChild.href}function f(a){var b=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"";return a&&!b?h(a):g(b)}function g(a){if("string"!=typeof a)throw new Error("`type` argument must be a string");return a&&~a.indexOf(";")?a.substr(0,a.indexOf(";")):a}function h(a){if("string"!=typeof a)throw new Error("`url` argument must be a string");var b=void 0;if(!Array.isArray(n))throw new Error("`typeChecks` must be an array");if(n.length)for(var c=0,d=n.length;d>c;c++){var e=n[c];if("function"!=typeof e)throw new Error("Element in array must be a function")}for(var f=0,g=n.length;g>f;f++)if(b=n[f](a),void 0!==b&&null!==b)return b;var h=i(a),k=j(h);return(/(mp4|m4v|ogg|ogv|webm|webmv|flv|wmv|mpeg|mov)/gi.test(h)?"video":"audio")+"/"+k}function i(a){if("string"!=typeof a)throw new Error("`url` argument must be a string");var b=a.split("?")[0];return~b.indexOf(".")?b.substring(b.lastIndexOf(".")+1):""}function j(a){if("string"!=typeof a)throw new Error("`extension` argument must be a string");switch(a){case"mp4":case"m4v":return"mp4";case"webm":case"webma":case"webmv":return"webm";case"ogg":case"oga":case"ogv":return"ogg";default:return a}}Object.defineProperty(c,"__esModule",{value:!0}),c.typeChecks=void 0,c.absolutizeUrl=e,c.formatType=f,c.getMimeFromType=g,c.getTypeFromFile=h,c.getExtension=i,c.normalizeExtension=j;var k=a("../core/mejs"),l=d(k),m=a("./general"),n=c.typeChecks=[];l["default"].Utils=l["default"].Utils||{},l["default"].Utils.absolutizeUrl=e,l["default"].Utils.formatType=f,l["default"].Utils.getMimeFromType=g,l["default"].Utils.getTypeFromFile=h,l["default"].Utils.getExtension=i,l["default"].Utils.normalizeExtension=j},{"../core/mejs":6,"./general":21}],23:[function(a,b,c){"use strict";function d(a){return a&&a.__esModule?a:{"default":a}}var e=a("global/document"),f=d(e);Array.prototype.indexOf||(Array.prototype.indexOf=function(a,b){throw new TypeError('"this" is null or not defined')}),void 0===f["default"].createEvent&&(f["default"].createEvent=function(){var a=void 0;return a=f["default"].createEventObject(),a.timeStamp=(new Date).getTime(),a.enumerable=!0,a.writable=!0,a.configurable=!0,a.initEvent=function(a,b,c){(void 0).type=a,(void 0).bubbles=!!b,(void 0).cancelable=!!c,(void 0).bubbles||((void 0).stopPropagation=function(){(void 0).stoppedPropagation=!0,(void 0).cancelBubble=!0})},a}),"function"!=typeof Object.assign&&(Object.assign=function(a,b){if(null===a||void 0===a)throw new TypeError("Cannot convert undefined or null to object");for(var c=Object(a),d=1;d<arguments.length;d++){var e=arguments[d];if(null!==e)for(var f in e)Object.prototype.hasOwnProperty.call(e,f)&&(c[f]=e[f])}return c}),Array.prototype.includes||Object.defineProperty(Array.prototype,"includes",{value:function(a,b){if(null===this||void 0===this)throw new TypeError('"this" is null or not defined');var c=Object(this),d=c.length>>>0;if(0===d)return!1;for(var e=0|b,f=Math.max(e>=0?e:d-Math.abs(e),0);d>f;){if(c[f]===a)return!0;f++}return!1}}),String.prototype.includes||(String.prototype.includes=function(){return-1!==String.prototype.indexOf.apply(this,arguments)}),String.prototype.startsWith||(String.prototype.startsWith=function(a,b){return b=b||0,this.substr(b,a.length)===a})},{"global/document":2}]},{},[23,5,4,8,15,12,9,10,11,13,14,16,17,18]);